function [ decoded_seq ] = ldpc_decode( bin_seq, H )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

if nargin<2
    Ha=load('ha.mat');
    H = ha.Ha;
end

block_length = size(H,2);
seq_length = size(bin_seq,2);

num_blocks = floor(seq_length/block_length) ;

% disp(['decoding ' num2str(num_blocks) ' blocks']);

% char to bit sequence
bin_seq = double(bin_seq - '0');
 
% BlockLength:    Total number of bits in a codeword,       n.      
% NumInfoBits:    Number of information bits in a codeword, k.
% NumParityBits   Number of parity bits in a codeword,      n-k.
% n:    size(H,2),  Number of columns in H
% k:    size(H,1),  Number of rows in H


l = fec.ldpcdec(H);

% l.OutputFormat ='Whole codeWord';
% l.OutputFormat ='Information part';
decoded_seq = [];

for i =1:num_blocks
    dec_block = decode(l, bin_seq( (i-1)*block_length +1: i*block_length ) );
    decoded_seq = [decoded_seq, dec_block];
end



end

