function [dec_seq1 dec_seq2 bin_seq1 bin_seq2 ] = ldpc_expt(org, code_location)

if nargin <1

    organism = {  'ecoli_bstr.flat',...
                  'ecoli_hs.flat',...
                  'ecoli_k12.flat',...
                  'ecoli_ed1a.flat',...
                  'ecoli_etech10407.flat'};
    num_organisms = 5;
    
    org = cell(num_organisms,1);
    
    for i = 1:num_organisms
        org{i} =  genbankread(organism{i});        
    end           
    
    code_location = 0;
end

num_organisms = length(org);
organism_seq = cell(num_organisms,1);

for i=1:num_organisms
    organism_seq{i} = org{i}.Sequence;
end

% Get locations of the invariant sequences
invar12 = load('invar12.mat');
idx1 = invar12.loc_1;
idx2 = invar12.loc_2;

%
ha=load('ha.mat');
H = ha.Ha;
blk_len = size(H,2);

num_seq = length(idx1);
dec_seq = cell(num_seq,1);

% extra_bits = 2*extra_nuc;
extra_nuc = 25;


% Get Code Locations 
% code_location : 0 - before the code (default)
% code_location : 1 - after the code
% code_location = 0;

if code_location ==0
    idx1 = [idx1(:,1)-extra_nuc idx1(:,2)];
    idx2 = [idx2(:,1)-extra_nuc idx2(:,2)];
    if idx1(1,1) <=0
        idx1(1,1) =1;
    end
    if idx2(1,1) <=0
        idx2(1,1) =1;
    end
else
    idx1 = [idx1(:,1) idx1(:,2)+extra_nuc];
    idx2 = [idx2(:,1) idx2(:,2)+extra_nuc];
    if idx1(end,2) >=length(organism_seq{1})
        idx1(end,2) =length(organism_seq{1});
    end
    if idx2(end,2) >=length(organism_seq{2})
        idx2(end,2) =length(organism_seq{2});
    end
end

% Decode the sequences
dec_seq1 = cell(num_seq,1);
dec_seq2 = cell(num_seq,1);

dec_organism1_seq = cell(num_seq,1);
dec_organism2_seq = cell(num_seq,1);

for i = 1:num_seq
    bin_seq1 = nuc2bin(organism_seq{1}(idx1(i,1):idx1(i,2)));
    dec_seq1{i} = ldpc_decode(bin_seq1,H);
    dec_organism1_seq{i} = bin2nuc(dec_seq1{i});
    
    bin_seq2 = nuc2bin(organism_seq{2}(idx2(i,1):idx2(i,2)));
    dec_seq2{i} = ldpc_decode(bin_seq2,H);
    dec_organism2_seq{i} = bin2nuc(dec_seq2{i});
end

end
